<template>
  <div class="column" style="height: inherit">
    <div class="col-shrink row text-center">
      <span class="col text-h5 nunito">Task library</span>
      <div class="column col-1">
        <q-btn push text-color="primary" size="md" icon="add" @click="newDialog"></q-btn>
      </div>
    </div>
    <div class="row col">
      <q-scroll-area
        class="col"
        :thumb-style="thumbStyle"
        :content-style="contentStyle"
        :content-active-style="contentActiveStyle"
        :bar-style="barStyle"
        style="height: 100%"
      >
        <q-list padding class="rounded-borders">
          <q-item
            clickable
            v-for="(task, index) in task_list"
            :key="'task' + index"
            class="task"
            :active="$props.selected === task"
            active-class="active"
          >
            <q-item-section @click="handleSelected(task)">
              <span class="nunito">{{ task }}</span>
            </q-item-section>
            <q-item-section class="task-button">
              <q-btn round text-color="grey" size="sm" icon="edit" @click="editDialog(task)"></q-btn>
            </q-item-section>
            <q-item-section class="task-button">
              <q-btn round text-color="grey" size="sm" icon="delete" @click="deleteDialog(task)"></q-btn>
            </q-item-section>
          </q-item>
        </q-list>
      </q-scroll-area>
      <div class="col-1 column" style="margin-top: 16px; margin-left: 24px">
        <q-btn push text-color="primary" size="md" icon="save" @click="handleSave" />
      </div>
    </div>
  </div>
</template>

<script lang="ts">
import { defineComponent, PropType, computed } from 'vue';
import { scrollBarStyle } from '../utils';
import { useQuasar } from 'quasar';
import { Scene } from 'src/models/workflow';

export default defineComponent({
  emits: ['selected', 'save', 'deleted'],
  props: {
    tasks: {
      type: Array as PropType<Array<string>>,
      default: () => [] as Array<string>,
    },
    selected: {
      type: String,
      default: () => '',
    },
  },

  setup(props, { emit }) {
    const $q = useQuasar();

    const task_list = computed(() => {
      return props.tasks;
    });

    const handleSelected = (task: string) => {
      if (props.selected === task) return;
      emit('selected', task);
    };

    const handleSave = () => {
      emit('save');
    };

    const taskDialogs = {
      newDialog: () => {
        $q.dialog({
          title: 'New task',
          message: 'Insert a name for your new task',
          prompt: {
            model: '',
            type: 'text', // optional
          },
          cancel: true,
          persistent: true,
        })
          .onOk((data: string) => {
            window.taskApi
              .writeTask({
                name: data,
                version: '0.0.1',
                scene: {
                  nodes: [],
                  blocks: [],
                  links: [],
                  container: {
                    center: {
                      x: 0,
                      y: 0,
                    },
                    scale: 1,
                  },
                } as Scene,
              })
              .catch((err) => console.log(err))
              .then((res) => console.log(res))
              .catch((err) => console.log(err));
          })
          .onCancel(() => {
            // console.log('>>>> Cancel')
          })
          .onDismiss(() => {
            // console.log('I am triggered on both OK and Cancel')
          });
      },

      deleteDialog: (taskName: string) => {
        $q.dialog({
          title: `Delete ${taskName} ?`,
          message: `Are you sure you want to delete task ${taskName}?`,
          cancel: true,
          persistent: true,
        })
          .onOk(() => {
            void window.taskApi.deleteTask(taskName).then((res) => {
              emit('deleted', taskName);
            });
            // console.log('>>>> OK')
          })
          .onOk(() => {
            // console.log('>>>> second OK catcher')
          })
          .onCancel(() => {
            // console.log('>>>> Cancel')
          })
          .onDismiss(() => {
            // console.log('I am triggered on both OK and Cancel')
          });
      },

      editDialog: (taskName: string) => {
        $q.dialog({
          title: `Rename task ${taskName}`,
          prompt: {
            model: taskName,
            isValid: (val: string) => val.length > 2,
            type: 'text', // optional
          },
          cancel: true,
          persistent: true,
        })
          .onOk((data: string) => {
            void window.taskApi.renameTask(taskName, data);
            // console.log('>>>> OK, received', data)
          })
          .onCancel(() => {
            // console.log('>>>> Cancel')
          })
          .onDismiss(() => {
            // console.log('I am triggered on both OK and Cancel')
          });
      },
    };

    return {
      ...scrollBarStyle,
      ...taskDialogs,
      handleSelected,
      handleSave,
      task_list,
    };
  },
});
</script>

<style lang="sass" scoped>
.task
  max-width: 98%

.task-button
  max-width: 30px

.active
  background: $blue-grey-1
</style>
